var path = require('path');
var fs = require('fs');
var replaceStream = require('replacestream');
var exec = require('child_process').exec;

Reveal.initialize({
  controls: false,
  progress: true,
  history: true,
  help:false,
  center: true,
  embedded: true,
  autoSlide: 10000,
  loop: true,
  keyboard: {
    13: 'next', // Enter
    37: 'prev', // Flecha Izq
    39: 'next', // Flecha Der
    38: null, // Flecha Arriba
    40: null, // Flecha Abajo
    70: function() {
        location.reload(true);
        } // refrescar página.
  },

  transition: 'slide',

  // Fondo paralaje
  parallaxBackgroundImage: 'css/fondo.svg',
  parallaxBackgroundSize: '1600px 900px',

    // Optional reveal.js plugins
  dependencies: [
  { src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
  { src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
  { src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
    { src: 'plugin/highlight/highlight.js', async: true, condition: function() { return !!document.querySelector( 'pre code' ); }, callback: function() { hljs.initHighlightingOnLoad(); } },
    { src: 'plugin/zoom-js/zoom.js', async: true },
      { src: 'plugin/notes/notes.js', async: true }
  ]
});

var botonAcercaDe = document.getElementById('botonAcercaDe');
var botonIzquierda = document.getElementById('botonIzquierda');
var botonDerecha = document.getElementById('botonDerecha');
var checkboxIniciar = document.getElementById('check');
var botonNuevoEnHuayra = document.getElementById('nuevo-en-huayra');

function actualizar_estados() {
  if (Reveal.isFirstSlide())
    botonIzquierda.setAttribute('disabled', 'disabled');
  else
    botonIzquierda.removeAttribute('disabled');

  if (Reveal.isLastSlide()) {
    botonDerecha.setAttribute('disabled', 'disabled');
  } else {
    botonDerecha.removeAttribute('disabled');
  }
}

Reveal.addEventListener('ready', actualizar_estados);
Reveal.addEventListener('slidechanged', actualizar_estados);

botonIzquierda.onclick = function() {
  // NOTA: usar Reveal.navigateLeft() si no queremos que ingrese en
  // los slides inferiores.
  Reveal.prev();
};

botonDerecha.onclick = function() {
  // NOTA: usar Reveal.navigateRight() si no queremos que ingrese en
  // los slides inferiores.
  Reveal.next();
};

botonAcercaDe.onclick = function(e) {
  e.preventDefault();
  Reveal.slide(-1, -1);
};


function copiar_archivo_no(desde, hasta, autostart) {
	//fs.createReadStream(desde).
    //pipe(replaceStream('Terminal=false', "NotShowIn=LXDE" )).
    //pipe(fs.createWriteStream(hasta));
    
    var sys = require('sys')
var exec = require('child_process').exec;
function puts(error, stdout, stderr) { sys.puts(stderr) ;
	var data = stderr;
	console.log(stderr);
	}
exec('cp ' + desde + ' ' + hasta, puts);


}

function copiar_archivo_si(desde, hasta, autostart) {

var sys = require('sys')
var exec = require('child_process').exec;
function puts(error, stdout, stderr) { sys.puts(stderr) ;
	var data = stderr;
	console.log(stderr);
	}
exec('rm '+ hasta, puts);

	
	
	//fs.createReadStream(desde).
    //pipe(replaceStream('NotShowIn='+ data, "Terminal=false")).
    //pipe(fs.createWriteStream(hasta));
}

function actualizar_acceso_inicio_automatico(reiniciar) {
  var ruta_desktop_original = "/usr/share/applications/lihuen-bullets.desktop";
  var ruta_desktop_home = path.join(process.env['HOME'], '.config/autostart/lihuen-bullets.desktop');

  if (reiniciar) {
	console.error("El archivo " + ruta_desktop_original + " no existe, no se puede cambiar preferencias de inicio...");
    copiar_archivo_no(ruta_desktop_original, ruta_desktop_home, reiniciar);
    
  } else {
    copiar_archivo_si(ruta_desktop_original, ruta_desktop_home, reiniciar);
	}

}

function mostrar_estado_iniciar_checkbox() {
  var ruta_desktop_home = path.join(process.env['HOME'], '.config/autostart/lihuen-bullets.desktop');

  if (fs.existsSync(ruta_desktop_home)) {
      checkboxIniciar.checked = true;
    }
  else {
    checkboxIniciar.checked = false;
  }
}

checkboxIniciar.onchange = function() {
  actualizar_acceso_inicio_automatico(checkboxIniciar.checked);
};

mostrar_estado_iniciar_checkbox();
